//
//  DetailVC.swift
//  SeachEvent
//
//  Created by igmstudent on 11/5/15.
//  Copyright © 2015 Shawn Ribaudo. All rights reserved.
//

import UIKit

class DetailVC: UITableViewController {

    let mySimpleCell = "SimpleCell"
    var event: Event?
    var e:EventManager = EventManager()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
        title = event?.title
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 5
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return 1
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier(mySimpleCell, forIndexPath: indexPath)
        
        //configure the cell...
        if indexPath.section == 0{
            cell.textLabel?.text = event?.title
            cell.textLabel?.font = UIFont.boldSystemFontOfSize(24.0)
        }
        
        //configure the cell...
        if indexPath.section == 1{
            cell.textLabel?.numberOfLines = 0
            cell.textLabel?.text = event?.subtitle
            cell.textLabel?.font = UIFont.boldSystemFontOfSize(14.0)
        }
        
        //configure the cell...
        if indexPath.section == 2{
            cell.textLabel?.text = "View on location"
            cell.textLabel?.textColor = view.tintColor // clickable blue
            cell.textLabel?.font = UIFont.systemFontOfSize(18.0)
            cell.textLabel?.textAlignment = NSTextAlignment.Center
        }
        
        if indexPath.section == 3{
            cell.textLabel?.text = "View on web"
            cell.textLabel?.font = UIFont.systemFontOfSize(18.0)
            cell.textLabel?.textColor = view.tintColor // clickable blue
            cell.textLabel?.textAlignment = NSTextAlignment.Center
        }
        
        
        if indexPath.section == 4{
            cell.textLabel?.text = "Add to favorite"
            cell.textLabel?.font = UIFont.systemFontOfSize(18.0)
            cell.textLabel?.textColor = view.tintColor // clickable blue
            cell.textLabel?.textAlignment = NSTextAlignment.Center
        }
        
        
        return cell
    }
    
    override func tableView(tableView: UITableView, heightForRowAtIndexPath indexPath: NSIndexPath) -> CGFloat {
       if indexPath.section == 1{
           return 100.0
       }
        return 44.0
    }
    
    override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        if indexPath.section == 3{
            if let url = NSURL(string: (event?.url)!){
                UIApplication.sharedApplication().openURL(url)
            }
        }
        
        if indexPath.section == 4{
            e.addFavorite(Event(title: (event?.title)!, start_time: (event?.start_time)!))
            EventManager.sharedInstance.addFavorite(event!)
            let favoriteVC : FavoriteVC = storyboard!.instantiateViewControllerWithIdentifier("FavoriteVC") as! FavoriteVC
            self.navigationController?.pushViewController(favoriteVC, animated: true)
            
        }
        
        if indexPath.section == 2{
            let mapDetailVC : MapDetailVC = storyboard!.instantiateViewControllerWithIdentifier("MapDetailVC") as! MapDetailVC
            
            mapDetailVC.event = event
            self.navigationController?.pushViewController((mapDetailVC), animated: true)
        }
        
    }
    
    //Code for sharing application and saving image is included as one of the options
    
    @IBAction func sharedTapped(sender: AnyObject) {
        let textToShare = event?.title
        let website = event?.url
        let detail = event?.subtitle
        let objectsToShare:[AnyObject] = [textToShare!, website!, detail!]
        let activityVC = UIActivityViewController(activityItems: objectsToShare, applicationActivities: nil)
        //self.presentViewController(activityVC, animated: true, completion: nil)
        
        if let pop = activityVC.popoverPresentationController {
            pop.sourceView = view
        }
        
        self.presentViewController(activityVC, animated: true, completion: nil)
    }
    
    /*
    // Override to support conditional editing of the table view.
    override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
        if editingStyle == .Delete {
            // Delete the row from the data source
            tableView.deleteRowsAtIndexPaths([indexPath], withRowAnimation: .Fade)
        } else if editingStyle == .Insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    /*
    // Override to support rearranging the table view.
    override func tableView(tableView: UITableView, moveRowAtIndexPath fromIndexPath: NSIndexPath, toIndexPath: NSIndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(tableView: UITableView, canMoveRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return false if you do not want the item to be re-orderable.
        return true
    }
    */

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
